diff --git a/src/backend/commands/pipelinecmds.c b/src/backend/commands/pipelinecmds.c
index 29b91f745..3775b0f3b 100644
--- a/src/backend/commands/pipelinecmds.c
+++ b/src/backend/commands/pipelinecmds.c
@@ -604,7 +604,7 @@ ExecCreateContViewStmt(CreateContViewStmt *stmt, const char *querystring)
 	/* Apply any CQ storage options like max_age, step_factor */
 	ApplyStorageOptions(stmt);
 
-	ValidateContQuery(stmt->into->rel, stmt->query, querystring);
+	ValidateParsedContQuery(stmt->into->rel, stmt->query, querystring);
 
 	/* Deparse query so that analyzer always see the same canonicalized SelectStmt */
 	cont_query = parse_analyze(copyObject(stmt->query), querystring, NULL, 0);
@@ -621,6 +621,7 @@ ExecCreateContViewStmt(CreateContViewStmt *stmt, const char *querystring)
 	workerselect = TransformSelectStmtForContProcess(matrel, copyObject(cont_select), &viewselect, Worker);
 
 	query = parse_analyze(copyObject(workerselect), cont_select_sql, 0, 0);
+	ValidateContQuery(query);
 
 	foreach(lc, query->groupClause)
 	{
@@ -1207,7 +1208,7 @@ ExecCreateContTransformStmt(CreateContTransformStmt *stmt, const char *querystri
 	CreateInferredStreams((SelectStmt *) stmt->query);
 	MakeSelectsContinuous((SelectStmt *) stmt->query);
 
-	ValidateContQuery(stmt->into->rel, stmt->query, querystring);
+	ValidateParsedContQuery(stmt->into->rel, stmt->query, querystring);
 	ValidateSubselect(stmt->query, "continuous transforms");
 
 	query = parse_analyze(copyObject(stmt->query), querystring, NULL, 0);
diff --git a/src/backend/pipeline/cont_analyze.c b/src/backend/pipeline/cont_analyze.c
index 59f8c04d7..348d3cf36 100644
--- a/src/backend/pipeline/cont_analyze.c
+++ b/src/backend/pipeline/cont_analyze.c
@@ -910,10 +910,10 @@ validate_target_list(SelectStmt *stmt)
 }
 
 /*
- * ValidateContQuery
+ * ValidateParsedContQuery
  */
 void
-ValidateContQuery(RangeVar *name, Node *node, const char *sql)
+ValidateParsedContQuery(RangeVar *name, Node *node, const char *sql)
 {
 	SelectStmt *select;
 	ContAnalyzeContext *context;
@@ -953,7 +953,7 @@ ValidateContQuery(RangeVar *name, Node *node, const char *sql)
 		RangeSubselect *sub = (RangeSubselect *) linitial(select->fromClause);
 
 		ValidateSubselect(sub->subquery, "subqueries in continuous views");
-		ValidateContQuery(name, sub->subquery, sql);
+		ValidateParsedContQuery(name, sub->subquery, sql);
 		return;
 	}
 
@@ -1423,6 +1423,60 @@ pull_var_and_aggs(Node *node)
 	return varlist;
 }
 
+/*
+ * validate_agg
+ */
+static void
+validate_agg(Node *node)
+{
+	Oid aggfnoid = InvalidOid;
+	HeapTuple	aggtup;
+	HeapTuple combtup;
+	Form_pg_aggregate aggform;
+
+	Assert(IsA(node, Aggref) || IsA(node, WindowFunc));
+
+	if (IsA(node, Aggref))
+		aggfnoid = ((Aggref *) node)->aggfnoid;
+	else
+		aggfnoid = ((WindowFunc *) node)->winfnoid;
+
+	aggtup = SearchSysCache1(AGGFNOID, ObjectIdGetDatum(aggfnoid));
+	Assert(HeapTupleIsValid(aggtup));
+
+	aggform = (Form_pg_aggregate) GETSTRUCT(aggtup);
+	ReleaseSysCache(aggtup);
+
+	combtup = SearchSysCache2(PIPELINECOMBINETRANSFNOID,
+			ObjectIdGetDatum(aggform->aggfinalfn), ObjectIdGetDatum(aggform->aggtransfn));
+
+	if (!HeapTupleIsValid(combtup))
+	{
+		if (aggform->aggtranstype == INTERNALOID)
+			elog(ERROR, "aggregate %u requires a pipeline_combine record but does not have one", aggfnoid);
+		return;
+	}
+
+	ReleaseSysCache(combtup);
+}
+
+/*
+ * ValidateContQuery
+ */
+void
+ValidateContQuery(Query *query)
+{
+	List *aggs = pull_var_and_aggs((Node *) query->targetList);
+	ListCell *lc;
+
+	foreach(lc, aggs)
+	{
+		Node *n = (Node *) lfirst(lc);
+		if (IsA(n, Aggref) || IsA(n, WindowFunc))
+			validate_agg(n);
+	}
+}
+
 static Oid
 get_combine_state_type(Expr *expr)
 {
diff --git a/src/include/pipeline/cont_analyze.h b/src/include/pipeline/cont_analyze.h
index 7a2475caa..962462cf1 100644
--- a/src/include/pipeline/cont_analyze.h
+++ b/src/include/pipeline/cont_analyze.h
@@ -61,7 +61,8 @@ extern ContAnalyzeContext *MakeContAnalyzeContext(ParseState *pstate, SelectStmt
 extern void CreateInferredStreams(SelectStmt *stmt);
 extern void MakeSelectsContinuous(SelectStmt *stmt);
 extern void ValidateSubselect(Node *subquery, char *objdesc);
-extern void ValidateContQuery(RangeVar *name, Node *node, const char *sql);
+extern void ValidateParsedContQuery(RangeVar *name, Node *node, const char *sql);
+extern void ValidateContQuery(Query *query);
 extern void ValidateContTrigger(CreateTrigStmt *stmt);
 
 extern void transformContSelectStmt(ParseState *pstate, SelectStmt *select);
